Description

In the latest versions of the Processing plugin (from 2.10 onwards), there are minor errors in the code. The following code should probably

be used to replace the existing code:

##Table=group

##Input=vector

##Fields=Field Input

##Frequency=output table

from processing.tools.vector import TableWriter

from collections import defaultdict

from processing.core.GeoAlgorithmExecutionException import GeoAlgorithmExecutionException

layer = processing.getObject(Input)    # Changed '(input)' to '(Input)'

inputFields = layer.pendingFields()

fieldIdxs = []

fields = Fields.split(',')    # Changed 'fields.split' to 'Fields.split'

for f in fields:

    idx = inputFields.indexFromName(f)

    if idx == -1:

        raise GeoAlgorithmExecutionException('Field not found:' + f)

    fieldIdxs.append(idx)

writer = TableWriter(Frequency, None, fields + ['FREQ'])    # Changed 'output' to 'Frequency'

counts = {}

feats = processing.features(layer)

nFeats = len(feats)

counts = defaultdict(int)

for i, feat in enumerate(feats):

    progress.setPercentage(int(100 * i / nFeats))

    attrs = feat.attributes()

    clazz = tuple([attrs[i] for i in fieldIdxs])

    print clazz

    counts[clazz] += 1

for c in counts:

    writer.addRecord(list(c) + [counts[c]])

This was reported from the GIS:Stack Exchange forum (
http://gis.stackexchange.com/questions/171002/proper-use-of-qgis-tool-frequency-analysis)

Associated revisions

Revision 7a879994 - 2016-01-13 09:55 AM - Victor Olaya

[processing] fixed frequency analysis algorithm

code provided by Joseph Liam

fixes #14090

History

#1 - 2016-01-12 05:32 AM - Jürgen Fischer

- File diff added

#2 - 2016-01-13 12:55 AM - Victor Olaya

- Status changed from Open to Closed

Fixed in changeset commit:"7a879994d49ecbfeae406fce566015cab172b4d9".
diff 1.11 KB 2016-01-12 Jürgen Fischer
